#!/bin/bash

# ======================================================================= #
# rdiff-backup test with '**' as prefix to --includes path and empty data
# directory structure contained in source
# ======================================================================= #

if [ ! -e /tmp/rdiff-data ]; then
    cp -R rdiff-data /tmp
fi

if [ ! -e /tmp/rdiff-test/bak ]; then
    mkdir -p /tmp/rdiff-test/bak
fi

if [ -e /tmp/rdiff-test/bak/data1 ]; then
    rm -r /tmp/rdiff-test/bak/data1
fi
if [ -e /tmp/rdiff-test/bak/data2 ]; then
    rm -r /tmp/rdiff-test/bak/data2
fi

# ----------------------------------

/usr/bin/rdiff-backup \
--exclude /tmp/rdiff-data/docs/tmp/'*' \
--include /tmp/rdiff-data/mediafiles/audio/Playlists \
--exclude /tmp/rdiff-data/mediafiles/audio/'*' \
--exclude /tmp/rdiff-data/ref/'*' \
--exclude /tmp/rdiff-data/software/'*' \
/tmp/rdiff-data /tmp/rdiff-test/bak/data1

echo
echo "Files only in /tmp/rdiff-data after [correct] backup:"
echo
diff -rq /tmp/rdiff-data /tmp/rdiff-test/bak/data1 | egrep "Only in /tmp/rdiff-data"
echo
echo
echo "Files only in /tmp/rdiff-test/bak/data1 after [correct] backup:"
echo
diff -rq /tmp/rdiff-data /tmp/rdiff-test/bak/data1 | egrep "Only in /tmp/rdiff-test/bak/data1"

echo
echo "------------------------------------------------"

/usr/bin/rdiff-backup \
--exclude /tmp/rdiff-data/docs/tmp/'*' \
--include '**'/mediafiles/audio/Playlists \
--exclude /tmp/rdiff-data/mediafiles/audio/'*' \
--exclude /tmp/rdiff-data/ref/'*' \
--exclude /tmp/rdiff-data/software/'*' \
/tmp/rdiff-data /tmp/rdiff-test/bak/data2

echo
echo "Files only in /tmp/rdiff-data after [incorrect] backup:"
echo
diff -rq /tmp/rdiff-data /tmp/rdiff-test/bak/data2 | egrep "Only in /tmp/rdiff-data"
echo
echo
echo "Files only in /tmp/rdiff-test/bak/data2 after [incorrect] backup:"
echo
diff -rq /tmp/rdiff-data /tmp/rdiff-test/bak/data2 | egrep "Only in /tmp/rdiff-test/bak/data2"

echo

# clean up
#rm -r /tmp/rdiff-data
#rm -r /tmp/rdiff-test
